
typedef unsigned char BYTE;

/* 063תΪɼַ */
char g_b64EncTable[65] =
	"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

BYTE g_b64DecTable[256] = {
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0x3e, 0xff, 0xff, 0xff, 0x3f,

	0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x3a, 0x3b,
	0x3c, 0x3d, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,

	0xff, 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06,
	0x07, 0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e,
	0x0f, 0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16,
	0x17, 0x18, 0x19, 0xff, 0xff, 0xff, 0xff, 0xff,

	0xff, 0x1a, 0x1b, 0x1c, 0x1d, 0x1e, 0x1f, 0x20,
	0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28,
	0x29, 0x2a, 0x2b, 0x2c, 0x2d, 0x2e, 0x2f, 0x30,
	0x31, 0x32, 0x33, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
};

/*
********************************************************************************
*   : ݿbase64
*   : 
*  pInput - 룬ǰݿ
*  nLength -  룬ݿ飨pInput
*  pOutput - base64ݿ飬СΪݵ4/3
*      ݿpInput ݿpOutput ʼַͬ
*  nOutBufSize- ,űݣpOutputĻС
*   : 
*     0:ڴűݵĻʧܡ
*     0ݳȣֵΪ(inputLen+2)/3*4
********************************************************************************
*/
int B64Encode(BYTE *pInput, int nLength, char *pOutput, int nOutBufSize)
{	
	int nModulus = nLength%3;
	int nOutLen = (nLength+2)/3*4; /* 4 */
	int nDatalen = nLength-nModulus;
	int i, j;
	int x, y, z;
	
	/* СУ */
	if(nOutBufSize < nOutLen)
	{
		return 0;
	}
	
	for (i=0, j=0; i<nDatalen; i+=3,j+=4)
	{
		x = pInput[i];
		y = pInput[i+1];
		z = pInput[i+2];
		pOutput[j] = g_b64EncTable[x/4];
		pOutput[j+1] = g_b64EncTable[(x%4)*16+y/16];
		pOutput[j+2] = g_b64EncTable[(y%16)*4+(z/64)];
		pOutput[j+3] = g_b64EncTable[z%64];
	}

	i = nDatalen;
	j = (nDatalen/3)*4;
	if (nModulus == 1)
	{
		x = pInput[i];
		pOutput[j] = g_b64EncTable[x/4];
		pOutput[j+1] = g_b64EncTable[(x%4)*16];
		pOutput[j+2] = '=';
		pOutput[j+3] = '=';
	}
	else if (nModulus == 2)
	{
		x = pInput[i];
		y = pInput[i+1];
		pOutput[j] = g_b64EncTable[x/4];
		pOutput[j+1] = g_b64EncTable[(x%4)*16+y/16];
		pOutput[j+2] = g_b64EncTable[(y%16)*4];
		pOutput[j+3] = '=';
	}
	return nOutLen; 
}

/*
********************************************************************************
*   : int B64Decode(char *pInput, int nLength, BYTE* pOutput)
*   : base64ݿbase64
*   : 
*  pInput - 룬base64ݿ
*  nLength -  룬base64ݿ鳤
*  pOutput - base64ݿ
*      ݿpInputݿpOutputʼַͬ
*   :
*  0: Чݣʧ  
*       0base64ݳ
********************************************************************************
*/
int B64Decode(char *pInput, int nLength, BYTE* pOutput)
{
	register int i,j;
	register int x, y, z, k;
	int nOutLen;
	int nPadBytes;
	int nDataLen;
	
	if(nLength%4 != 0)
	{
		return 0; 
	}

	/* '='ĸжϱǰݵĳ */
	if(pInput[nLength-2] == '=')
	{
		nPadBytes = 2;
	}
	else if(pInput[nLength-1] == '=')
	{
		nPadBytes = 1;
	}
	else
	{
		nPadBytes = 0;
	}

	nOutLen = nLength/4*3 - nPadBytes;
	nDataLen = (nLength-nPadBytes)/4*3;
	
	/* ʼ */
	for(i=0, j=0; i<nDataLen; i+=3, j+=4)
	{
		x = g_b64DecTable[pInput[j]];
		y = g_b64DecTable[pInput[j+1]];
		z = g_b64DecTable[pInput[j+2]];
		k = g_b64DecTable[pInput[j+3]];
		if (x==0xff || y==0xff || z==0xff || k==0xff)
		{
			return 0;
		}
		pOutput[i] = (x<<2)|(y>>4);
		pOutput[i+1] = ((y&15)<<4)|(z>>2);
		pOutput[i+2] = ((z&3)<<6)|k;
	}

	i = nDataLen;
	if (nPadBytes == 1)
	{
		x = g_b64DecTable[pInput[j]];
		y = g_b64DecTable[pInput[j+1]];
		z = g_b64DecTable[pInput[j+2]];

		pOutput[i] = (x<<2)|(y>>4);
		pOutput[i+1] = ((y&15)<<4)|(z>>2);
	}
	else if (nPadBytes == 2)
	{
		x = g_b64DecTable[pInput[j]];
		y = g_b64DecTable[pInput[j+1]];

		pOutput[i] = (x<<2)|(y>>4);
	}
	return nOutLen;
}
