
#if !defined(HIDDEVICE1_H)
#define HIDDEVICE1_H

#include "types.h"

class CHidPort;
class CHidDevice  
{
public:
	CHidDevice(WORD wVendorID, WORD wProductID);
	virtual ~CHidDevice();

	int SetKey(int nKeyType, BYTE *keyData, int nKeyLen, 
    BYTE KeyVersion[128], BYTE iMAC[8], BYTE Random[8]);
	int DeleteKey(int nKeyType, BYTE *KeyBuffer, int nKeyLen,
		BYTE KeyVersion[128], BYTE iMAC[8], BYTE Random[8]);
	int GetKeyVersion(int nKeyType, BYTE version[128]);

	int GetImage152X200(BYTE Sha1[20], BYTE Random[8], 
    BYTE imageData[], BYTE oMac[8]);
	int GetFeature(int nTimeOut, int nFeatLen, BYTE tzData[512]);
	int GetCryptFeature(int nTimeOut, BYTE random[8], BYTE tzData[512]);
	int ReadVersion(WORD nBufSize, char* lpVersion);
	int GetDeviceID(WORD wBufSize, char* lpDeviceID);
	int SetDeviceID(char* lpDeviceID, int nIdLength);
	int UpdateDevice(BYTE* lpCodeData, int nCodeLength);

	void Cancel();
	int IsCanceled();
private:
	int SetKey(CHidPort* lpHidPort, int nKeyType, BYTE *keyData, int nKeyLen,
		BYTE keyVersion[128], BYTE keyMac[8], BYTE random[8]);
	int DeleteKey(CHidPort* lpHidPort, int nKeyType, BYTE *KeyData, int nKeyLen,
		BYTE keyVersion[128], BYTE keyMAC[8], BYTE random[8]);
	int GetKeyVersion(CHidPort* lpHidPort, int nKeyType, BYTE version[128]);

	int ReadVersion(CHidPort* lpHidPort, WORD nBufSize, char* lpVersion);
	int CheckVersion(CHidPort* lpHidPort, char* lpDevVersion, int nVersionLen);
	int SetDeviceID(CHidPort* lpHidPort, char* lpDeviceID, int nIdLength);

	void TransImage(BYTE imgData[], int nWidth, int nHeight);
	int GetImage152X200(CHidPort* lpHidPort, BYTE imageData[]);
	int GetImage152X200Sha1(CHidPort* lpHidPort, BYTE Sha1[20], 
    BYTE Random[8], BYTE oMac[8]);

	int GetImageFeature(CHidPort* lpHidPort, int nFeatLen, int nImageNo, 
		int nTimeOut, int nFlag, BYTE tzData[256]);
	int DownFeature(CHidPort* lpHidPort, BYTE tzData[256]);
	int UpCryptFeature(CHidPort* lpHidPort, BYTE random[8], BYTE* tzData);

	int ReadImage(CHidPort* lpHidPort);
	int DetectFinger(CHidPort* lpHidPort, int nTimeOut);
	int DetectOffFinger(CHidPort* lpHidPort);
	int UpImg(CHidPort* lpHidPort, BYTE* pImgBuf);
	int ImgToFeature(BYTE imgData[152*200], int nWidth, 
    int nHeight, int nFeatLen, BYTE tzData[512]);

	int StartCapFinger(CHidPort* lpHidPort);
	int StopCapFinger(CHidPort* lpHidPort);
	
	int LedControl(CHidPort* lpHidPort, BYTE nLedID, BYTE onOff);
	int RedLedOn(CHidPort* lpHidPort);
	int GreenLedOn(CHidPort* lpHidPort);
	int LedOff(CHidPort* lpHidPort);
	int CheckFinger(CHidPort* lpHidPort);

	int UpdateDevice(CHidPort* lpHidPort, BYTE* lpCodeData, int nCodeLength);
	
	BYTE m_imgData[4][256*360];
	int m_bCanceled;

	WORD m_wVendorID;
	WORD m_wProductID;
private:
	int ExeCommand(CHidPort* lpHidPort, BYTE nCommandID,
    WORD wReqLen, BYTE* lpReqData, WORD wBufSize, 
    WORD* lpDataLen, BYTE* lpData, int nTimeOut);
};

#endif
