
#include <string.h>

#include "des.h"

int get_fill_len(unsigned char fill_bytes[8])
{
	int i;
	int fill_len;
	
	if (fill_bytes==0 || fill_bytes[7]>8)
	{
		return 0;
	}
	
	fill_len = fill_bytes[7];
	for (i=7; i>=8-fill_len; i--)
	{
		if (fill_bytes[i] != fill_len)
		{
			return 0;
		}
	}
	return fill_len;
}

/** : 3des
    : key-Կ, in_data-, in_data_len-ĳ
         : out_data-, out_len-ĳ
*/
void des3_decrypt_data(unsigned char key[16], unsigned char* in_data, 
  unsigned int in_data_len, unsigned char* out_data, unsigned int* out_len)
{
	DES_cblock key1, key2, key3;
	DES_key_schedule sk1, sk2, sk3;
	DES_cblock in, out;
	
	unsigned int block_size;
	unsigned int i;
	
	memcpy(key1, key, 8);
	memcpy(key2, key+8, 8);
	memcpy(key3, key, 8);
	
	DES_set_key_unchecked(&key1, &sk1);
	DES_set_key_unchecked(&key2, &sk2);
	DES_set_key_unchecked(&key3, &sk3);
	
	block_size = in_data_len/8;
	*out_len = 0;
	if (in_data_len%8 != 0)
	{
		return;
	}
	for (i=0; i<block_size; i++)
	{
		memcpy(in, in_data+8*i, 8);
		memset(out, 0x30, 8);
		DES_ecb3_encrypt(&in, &out, &sk1,
			&sk2, &sk3, DES_DECRYPT);
		if (i < block_size-1)
		{
			memcpy(out_data+(*out_len), out, 8);
			(*out_len) += 8;
		}
		else
		{
			unsigned int fill_len = get_fill_len(out);
			if (fill_len>0 && fill_len<=8)
			{
				unsigned int len = 8-fill_len;
				memcpy(out_data+(*out_len), out, len);
				(*out_len) += len;
			}
			else
			{
				if (out[7] != 0)
				{
					(*out_len) = 0;
				}
			}
		}
	}
}

